<?php
/**
 * 饦ɰ
 */

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGround.class.php";

/***
 * @internal
 * @public
 */
class BBSB_ViewGroundlistAction extends BBSB_AbstractEditAction
{
	/**
	 * 쥳ɺå
	 * @var unknown_type
	 */
	var $mDelMsg			= null;

	/**
	 * 饦ɥǡ
	 * @var unknown_type
	 */
	var $mGrList			= array();

	/**
	 * Ը¤Ĥɤ
	 * @var unknown_type
	 */
	var $mAdminMode			= null;

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$this->mAdminMode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$this->mAdminMode ){
			$controller->executeForward(XOOPS_URL . '/');
		}
	}

	function getDefaultView(&$controller, &$xoopsUser)
	{
		// ⡼ɻ
		if( xoops_getrequest('del') ){
			$this->mDelMsg = _MD_BBSB_INFO_DELOK;	// MSG
		}

		$dbGr = new BBSB_DbGround();
		// Ƚ
		$sortarray= array( '1'=>'GroundID', '2'=>'GroundName' );
		if( xoops_getrequest('sort') ){
			$sort = xoops_getrequest('sort');
			if( $sort >= 0 ){
				$dir = 'ASC';
			} else {
				$dir = 'DESC';
				$sort = -$sort;
			}
			$dbGr->setOrderBy( $sortarray[$sort], $dir);
		} else {
			// ǥեɽϡ֥饦̾
			$dbGr->setOrderBy( 'GroundName', 'ASC');
		}
		// ȯ
		$this->mGrList = $dbGr->getListbyCond('bb_ground', "GroundID,GroundName,Url" );
		if( $this->mGrList === false ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		return BBSB_FRAME_VIEW_INDEX;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		$render->setTemplateName("bbsb_viewgroundlist.html");
		$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE);

		$render->setAttribute('delmsg',			$this->mDelMsg);		// å
		$render->setAttribute("grlist",			$this->mGrList);		// 饦ɾ
	}

	/**
	 * 顼ν
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

}
?>