<?php
/**
 * С
 */

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbMember.class.php";

/***
 * @internal
 * @public
 */
class BBSB_ViewMemberlistAction extends BBSB_AbstractEditAction
{
	/**
	 * 쥳ɺå
	 * @var unknown_type
	 */
	var $mDelMsg			= null;

	/**
	 * Сǡ
	 * @var unknown_type
	 */
	var $mMeList			= array();

	/**
	 * Ը¤Ĥɤ
	 * @var unknown_type
	 */
	var $mAdminMode			= null;

	function getDefaultView(&$controller, &$xoopsUser)
	{
		// ⡼ɻ
		if( xoops_getrequest('del') ){
			$this->mDelMsg = _MD_BBSB_INFO_DELOK;	// MSG
		}

		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$this->mAdminMode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}

		$dbMe = new BBSB_DbMember();
		// Ƚ
		$sortarray= array( '1'=>'ShowOrder', '2'=>'UniformNo' );
		if( xoops_getrequest('sort') ){
			$sort = xoops_getrequest('sort');
			if( $sort >= 0 ){
				$dir = 'ASC';
				$colnull = $sortarray[$sort] . " IS NULL ";	// ˤNULLˤΤǡʤʤ褦н
				$dbMe->setOrderBy( $colnull, $dir);
				$dbMe->setOrderBy( $sortarray[$sort], $dir);
			} else {
				$dir = 'DESC';
				$sort = -$sort;
				$dbMe->setOrderBy( $sortarray[$sort], $dir);
			}
		} else {
			// ǥեɽShowOrderȤ
			$sort	= "ShowOrder";
			$dir	= "ASC";
			$dbMe->setOrderBy( $sort . " IS NULL ", $dir);
			$dbMe->setOrderBy( $sort, $dir);
		}
		// ȯ
		$this->mMeList = $dbMe->getListbyCond('bb_member');
		if( $this->mMeList === false ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		$position = array(	"Position1", "Position2", "Position3",
							"Position4", "Position5", "Position6",
							"Position7", "Position8", "Position9" );
		foreach( $this->mMeList as $mkey => &$mdat ){
			if( !$this->mAdminMode && $mdat['ProfileEntry'] != '1' ){	// ԰ʳξǡץեɽоݳˤʤäƤϥåפ롣(ɽʤ)
				unset($this->mMeList[$mkey]);
			}
			// ݥ
			$posstr = "";
			foreach( $position as $pos ){
				$posnum = $mdat[$pos];
				if( $posnum ){
					$mdat[$pos] = $this->getPositionStr( $posnum );
				} else {
					$mdat[$pos] = "";
				}
			}
			// ɽݡץեɽ
			if( $mdat['ScoreEntry'] ){
				$mdat['ScoreEntry'] = "Yes";
			} else {
				$mdat['ScoreEntry'] = "No";
			}
			if( $mdat['ProfileEntry'] ){
				$mdat['ProfileEntry'] = "Yes";
			} else {
				$mdat['ProfileEntry'] = "No";
			}
			// 
			$birth = $mdat['BirthYear'];
			if( $birth ){
				if( $mdat['BirthMonth'] ){
					$birth .= "-" . $mdat['BirthMonth'];
					if( $mdat['BirthDay'] ){
						$birth .= "-" . $mdat['BirthDay'];
					}
				}
			} else {
				$birth = "";
			}
			$mdat['BirthStr'] = $birth;
			// ե뤬ʤȤϥǥեȲ
			if( !$mdat['ImgFile'] ){
				$mdat['ImgFile'] = "NoPhoto.jpg";
			}
			// ̾
			if( $this->mAdminMode ){
				$nn = "";
				if( $mdat['NickName'] ){
					$nn = "(" . $mdat['NickName'] . ")";
				}
				$mdat['Name'] = $mdat['FullName'] . $nn;
			} else {
				if( _BBSB_OP_REALNAME ){
					// ̾ɽͭΤȤ
					$mdat['Name'] = $mdat['FullName'];
				} else {
					// ̾ɽ̵ΤȤϥ˥å͡ɽ(˥å͡बΤ)
					if( $mdat['NickName'] ){
						$mdat['Name'] = $mdat['NickName'];
					} else {
						$mdat['Name'] = $mdat['FullName'];
					}
				}
			}
		}

		return BBSB_FRAME_VIEW_INDEX;
	}

	/**
	 * ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		// ܥ󲡲delɬ
		if( !xoops_getrequest('del') ){
			$controller->executeForward(XOOPS_URL . '/');
		}
		$uid = xoops_getrequest('del');

		// delϺ⡼()
		$adminmode = null;
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		// ơ֥
		$dbM = new BBSB_DbMember();
		$dbM->setData( 'UserID',	$uid );
		$ret = $dbM->delete('bb_member');

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		$render->setTemplateName("bbsb_viewmemberlist.html");
		$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE . _BBSB_OP_BBSB_COMMON_JS );

		$render->setAttribute('adminmode',		$this->mAdminMode);		// ¤Τ桼ɤ
		$render->setAttribute('delmsg',			$this->mDelMsg);		// å
		$render->setAttribute("mlist",			$this->mMeList);		// С
	}

	/**
	 * ΤȤа̤(̺ɽ)
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$del	= xoops_getrequest('del');
		if( $del ){
			$del = "&del=" . $del;
		}
		$controller->executeForward("./index.php?action=ViewMemberlist" . $del );
	}

	/**
	 * 顼ν
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}
}
?>