<?php
/**
 * 
 */

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbOpponent.class.php";

/***
 * @internal
 * @public
 */
class BBSB_ViewOpponentlistAction extends BBSB_AbstractEditAction
{
	/**
	 * 쥳ɺå
	 * @var unknown_type
	 */
	var $mDelMsg			= null;

	/**
	 * ǡ
	 * @var unknown_type
	 */
	var $mOpList			= array();

	/**
	 * Ը¤Ĥɤ
	 * @var unknown_type
	 */
	var $mAdminMode			= null;

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$this->mAdminMode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$this->mAdminMode ){
			$controller->executeForward(XOOPS_URL . '/');
		}
	}

	function getDefaultView(&$controller, &$xoopsUser)
	{
		// ⡼ɻ
		if( xoops_getrequest('del') ){
			$this->mDelMsg = _MD_BBSB_INFO_DELOK;	// MSG
		}

		$dbOp = new BBSB_DbOpponent();
		// Ƚ
		$sortarray= array( '1'=>'TeamID', '2'=>'TeamName', '3'=>'BasePlace', '4'=>'LastGameDate');
		if( xoops_getrequest('sort') ){
			$sort = xoops_getrequest('sort');
			if( $sort >= 0 ){
				$dir = 'ASC';
			} else {
				$dir = 'DESC';
				$sort = -$sort;
			}
			$dbOp->setOrderBy( $sortarray[$sort], $dir);
		} else {
			// ǥեɽϡֺǿι߽ nullǽˤ褦θ롣
			$dbOp->setOrderBy( 'LastGameDate IS NULL', 'DESC');
			$dbOp->setOrderBy( 'LastGameDate', 'DESC');
		}
		// ȯ
		$this->mOpList = $dbOp->getListbyCond('bb_opponent', "TeamID,TeamName,BasePlace,Url,DATE_FORMAT(LastGameDate,'%Y-%m-%d') AS LastGameDate" );
		if( $this->mOpList === false ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		return BBSB_FRAME_VIEW_INDEX;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		$render->setTemplateName("bbsb_viewopponentlist.html");
		$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE);

		$render->setAttribute('adminmode',		$this->mAdminMode );	// ¤Τ桼ɤ
		$render->setAttribute('delmsg',			$this->mDelMsg);		// å
		$render->setAttribute("oplist",			$this->mOpList);		// 
	}

	/**
	 * 顼ν
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

}
?>