<?php
// ԡǡܹ

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/admin/forms/AdminSwitchOverForm.class.php";	// ե९饹
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGame.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGameEntrant.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGameBatter.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGamePitcher.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGameOrder.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGround.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbLeague.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbMember.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbOpponent.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbTournament.class.php";

class BBSB_SwitchOverAction extends BBSB_AbstractEditAction
{

	/**
     * ꥹ
     */
    var $mGameList = array();
	var $mSid = null;		// 塼ID

    /**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditGamedetailAction#_setupActionForm()
     */
    function _setupActionForm()
	{
		$this->mActionForm =& new BBSB_SwitchOverForm();
		$this->mActionForm->prepare();
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		return BBSB_FRAME_VIEW_INPUT;
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}
	}

	/**
	 * ܹԽ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		$this->mActionForm->load($this->mObject);	// DBͤɬפ硢ǥǡɤ롩
		$this->mActionForm->fetch();				// ꥯȥեफͤμ
		$this->mActionForm->validate();				// ͭͤ

		if( $this->mActionForm->mFormProperties['method']->mValue == "dir" ){
			// ǥ쥯ȥѥΰܹԤξ
			$wpath = $this->mActionForm->mFormProperties['websbpath']->mValue;
			if( !file_exists( $wpath ) ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DIRNOTFOUND . ":" . $wpath );
				return BBSB_FRAME_VIEW_INPUT;
			}

			// С (mst/member.cgi)  1:ֹ桢2:Ļ3:̾11:оݳե饰
			$memberfile="$wpath/mst/member.cgi";
			$ret = $this->insMemberFromFile( $memberfile );	// ХꥹȤDBϿ
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return $ret;
			}

			// 饦 (mst/gr.cgi)  1:饦̾
			$groundfile = "$wpath/mst/gr.cgi";
			$ret = $this->insGroundFromFile( $groundfile );	// 饦ɥꥹȤDBϿ
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return $ret;
			}

			// ꡼̾ (mst/syusai.cgi) 1:꡼̾
			$leaguefile = "$wpath/mst/syusai.cgi";
			$ret = $this->insLeagueFromFile( $leaguefile );	// ꡼ꥹȤDBϿ
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return $ret;
			}

			// ȡʥ()̾ (mst/taikai.cgi) 1:ȡʥ̾
			$tournamentfile = "$wpath/mst/taikai.cgi";
			$ret = $this->insTournamentFromFile( $tournamentfile );	// ȡʥȥꥹȤDBϿ
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return $ret;
			}

			// ̾ (mst/kaisen.cgi) 1:̾
			$gameorderfile = "$wpath/mst/kaisen.cgi";
			$ret = $this->insGameOrderFromFile( $gameorderfile );	// ꥹȤDBϿ
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return $ret;
			}

			// ǡ(data/seisekiyyyymmdd-n.txt
			$dirname = "$wpath/data/";
			$dirarray = scandir( $dirname );
			foreach( $dirarray as $key => $file ){	// եΥ롼
				if( strpos($file,'seiseki')===0 ){
					// ǡݡ
					$ret = $this->insGameFromFile( $dirname . $file );
					if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
						return $ret;
					}
				}
			}
			return BBSB_FRAME_VIEW_INPUT;

		} else {
			// TODO ǥ쥯ȥѥʳ
			//  եľܥåץɡwebڡΰܹԤʤ

		}

		return BBSB_FRAME_VIEW_INPUT;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
	}

	/**
	 * եѥӥ塼
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewInput(&$controller, &$xoopsUser, &$render)
	{
		$render->setTemplateName("admin_switchover.html");
		$render->setAttribute("actionForm", $this->mActionForm);
	}

	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
	}

	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
	}

	/**
	 * СꥹȤɤ߹bb_menbar롣
	 * ̾ʸNickName¸ߤƤϤǤ˥СϿƤȤߤʤINSERTԤʤ
	 * @param $file
	 * @return unknown_type
	 */
	function insMemberFromFile( $file )
	{
		// եեޥåȡ
		// 1:ֹ桢2:Ļ3:̾11:оݳե饰
		if( !file_exists( $file ) ){
			// file not found
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		$f = file( $file, FILE_IGNORE_NEW_LINES );
		if( $f === false ){
			// file read error
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		$dbMem = new BBSB_DbMember();
		foreach( $f as $key => $buf ){
			$buf = mb_convert_encoding( $buf, _CHARSET, "SJIS" );	// ʸѴ
			$lst = explode( ',', $buf );
			$dbMem->unsetData();
			$name = $lst[1] . $lst[2];
			$dbMem->setData('NickName', $name);
			$ret = $dbMem->CountNum('bb_member');					// NickNameˡס̾פʸ¸ߤƤ餹Ǥ¸ߤȤߤʤ
			if( $ret == 0 ){
				// 쥳ɤʤΤINSERT롣
				$name = $lst[1] . $lst[2];
				$dbMem->setData('FullName',		$name);				// ̾ȥ˥å͡ϤȤꤢƱΤ򥻥å
				$dbMem->setData('NickName',		$name);
				$dbMem->setData('UniformNo',	$lst[0]);
				$s = $lst[10]? 0 : 1;								// ScoreEntryϲդ˥åȤ롣
				$dbMem->setData('ScoreEntry',	$s);
				$val = '1';
				$dbMem->setData('ProfileEntry',	$val);				// ץեϿϥǥեȤON
				$rc = $dbMem->insert('bb_member');
				if( $rc === false ){
					// insert error
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":MemberData:"  . $lst[1] . $lst[2] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			}
		}
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":MemberData:" . $file );
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * 饦ɥꥹȤɤ߹bb_ground롣
	 * @param $file
	 * @return unknown_type
	 */
	function insGroundFromFile( $file )
	{
		// եեޥåȡ
		// 1:饦̾
		if( !file_exists( $file ) ){
			// file not found
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		$f = file( $file, FILE_IGNORE_NEW_LINES );
		if( $f === false ){
			// file read error
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		$dbGr = new BBSB_DbGround();
		foreach( $f as $key => $buf ){
			$buf = mb_convert_encoding( $buf, _CHARSET, "SJIS" );	// ʸѴ
			$lst = explode( ',', $buf );
			$dbGr->unsetData();
			$dbGr->setData('GroundName', $lst[0]);
			$ret = $dbGr->CountNum('bb_ground');					// ̾ǤǤDB¸ߤƤ뤫ɤå
			if( $ret == 0 ){
				// 쥳ɤʤΤINSERT롣
				$rc = $dbGr->insert('bb_ground');
				if( $rc === false ){
					// insert error
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GroundData:"  . $lst[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			}
		}
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":GroundData:" . $file );
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ꡼()ꥹȤɤ߹bb_league롣
	 * @param $file
	 * @return unknown_type
	 */
	function insLeagueFromFile( $file )
	{
		// եեޥåȡ
		// 1:꡼()̾
		if( !file_exists( $file ) ){
			// file not found
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		$f = file( $file, FILE_IGNORE_NEW_LINES );
		if( $f === false ){
			// file read error
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		$dbLe = new BBSB_DbLeague();
		foreach( $f as $key => $dat ){
			$dat = mb_convert_encoding( $dat, _CHARSET, "SJIS" );	// ʸѴ
			$lst = explode(',',$dat);
			$dbLe->unsetData();
			$dbLe->setData('LeagueName', $lst[0]);
			$ret = $dbLe->CountNum('bb_league');					// ꡼̾ǤǤDB¸ߤƤ뤫ɤå
			if( $ret == 0 ){
				// 쥳ɤʤΤINSERT롣
				$rc = $dbLe->insert('bb_league');
				if( $rc === false ){
					// insert error
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":LeagueData:"  . $lst[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			}
		}
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":LeagueData:" . $file );
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ȡʥ()ꥹȤɤ߹bb_tournament롣
	 * @param $file
	 * @return unknown_type
	 */
	function insTournamentFromFile( $file )
	{
		// եեޥåȡ
		// 1:ȡʥ̾
		if( !file_exists( $file ) ){
			// file not found
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		$f = file( $file, FILE_IGNORE_NEW_LINES );
		if( $f === false ){
			// file read error
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		$dbTr = new BBSB_DbTournament();
		foreach( $f as $key => $dat ){
			$dat = mb_convert_encoding( $dat, _CHARSET, "SJIS" );	// ʸѴ
			$lst = explode(',',$dat);
			$dbTr->unsetData();
			$dbTr->setData('TournamentName', $lst[0]);
			$ret = $dbTr->CountNum('bb_tournament');					// ȡʥ̾ǤǤDB¸ߤƤ뤫ɤå
			if( $ret == 0 ){
				// 쥳ɤʤΤINSERT롣
				$rc = $dbTr->insert('bb_tournament');
				if( $rc === false ){
					// insert error
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":TournamentData:"  . $lst[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			}
		}
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":TournamentData:" . $file );
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ꥹȤɤ߹bb_gameorder롣
	 * @param $file
	 * @return unknown_type
	 */
	function insGameOrderFromFile( $file )
	{
		// եեޥåȡ
		// 1:̾
		if( !file_exists( $file ) ){
			// file not found
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		$f = file( $file, FILE_IGNORE_NEW_LINES );
		if( $f === false ){
			// file read error
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		$dbGO = new BBSB_DbGameOrder();
		foreach( $f as $key => $dat ){
			$dat = mb_convert_encoding( $dat, _CHARSET, "SJIS" );	// ʸѴ
			$lst = explode(',',$dat);
			$dbGO->unsetData();
			$dbGO->setData('GameOrderName', $lst[0]);
			$ret = $dbGO->CountNum('bb_gameorder');					// ̾ǤǤDB¸ߤƤ뤫ɤå
			if( $ret == 0 ){
				// 쥳ɤʤΤINSERT롣
				$rc = $dbGO->insert('bb_gameorder');
				if( $rc === false ){
					// insert error
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GameOrderData:"  . $lst[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			}
		}
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":GameOrderData:" . $file );
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ꥹȤɤ߹bb_game롣
	 * @param $file
	 * @return unknown_type
	 */
	function insGameFromFile( $file )
	{
		if( !file_exists( $file ) ){
			// file not found
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		// ǡեɤ߹
		$f = file( $file, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES );	// Ժ&ɤФ
		if( $f === false ){
			// file read error
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILEREADERROR . ":"  . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		// ʸѴ
		foreach( $f as $key => &$dat ){
			$dat = mb_convert_encoding( $dat, _CHARSET, "SJIS" );
		}
		$dbGa = new BBSB_DbGame();						// ơ֥륤󥹥
		$EventDate	= substr(basename($file),7,8);		// 糫դϥե̾
		$GameSeq	= substr(basename($file),16,1);		// ϥե̾

		// ̾DBϿƤʤХơ֥Ͽ
		$TournamentID		= null;
		$TournamentName		= substr( strstr($f[1],'='), 1);	//̾
		if( $TournamentName ){
			$dbTr				= new BBSB_DbTournament();
			$dbTr->setData( 'TournamentName', $TournamentName );
			$ret = $dbTr->getListbyCond( 'bb_tournament', 'TournamentID', _BBSB_LIMIT_1 );
			if( $ret == null ){
				$ret = $dbTr->insert('bb_tournament');
				if( $ret === false ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Tournament:"  . $TournamentName );
					return BBSB_FRAME_VIEW_INPUT;
				}
				$TournamentID = $dbTr->mDb->getInsertId();
				if( !$TournamentID ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Tournament:"  . $TournamentName );
					return BBSB_FRAME_VIEW_INPUT;
				}
			} else {
				$TournamentID = $ret[0]['TournamentID'];
			}
		}

		// ̾DBϿƤʤХơ֥Ͽ
		$GameOrderID		= null;
		$GameOrderName		= substr( strstr($f[2],'='), 1);	// ̾
		if( $GameOrderName ){
			$dbGO				= new BBSB_DbGameOrder();
			$dbGO->setData( 'GameOrderName', $GameOrderName );
			$ret = $dbGO->getListbyCond( 'bb_gameorder', 'GameOrderID', _BBSB_LIMIT_1 );
			if( $ret == null ){
				$ret = $dbGO->insert('bb_gameorder');
				if( $ret === false ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GameOrder:"  . $GameOrderName );
					return BBSB_FRAME_VIEW_INPUT;
				}
				$GameOrderID = $dbGO->mDb->getInsertId();
				if( !$GameOrderID ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GameOrder:"  . $GameOrderName );
					return BBSB_FRAME_VIEW_INPUT;
				}
			} else {
				$GameOrderID = $ret[0]['GameOrderID'];
			}
		}

		// ̾(꡼̾)DBϿƤʤХơ֥Ͽ
		$LeagueID			= null;
		$LeagueName			= substr( strstr($f[3],'='), 1);	// ꡼̾
		if( $LeagueName ){
			$dbLg				= new BBSB_DbLeague();
			$dbLg->setData( 'LeagueName', $LeagueName );
			$ret = $dbLg->getListbyCond( 'bb_league', 'LeagueID', _BBSB_LIMIT_1 );
			if( $ret == null ){
				$ret = $dbLg->insert('bb_league');
				if( $ret === false ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":League:"  . $LeagueName );
					return BBSB_FRAME_VIEW_INPUT;
				}
				$LeagueID = $dbLg->mDb->getInsertId();
				if( !$LeagueID ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":League:"  . $LeagueName );
					return BBSB_FRAME_VIEW_INPUT;
				}
			} else {
				$LeagueID = $ret[0]['LeagueID'];
			}
		}

		// ǯټ
		$Nendo				= substr( strstr($f[4],'='), 1);	// ǯ

		// 饦̾DBϿƤʤХơ֥Ͽ
		$GroundID			= null;
		$GroundName			= substr( strstr($f[5],'='), 1);	// 饦̾
		if( $GroundName ){
			$dbGr				= new BBSB_DbGround();
			$dbGr->setData( 'GroundName', $GroundName );
			$ret = $dbGr->getListbyCond( 'bb_ground', 'GroundID', _BBSB_LIMIT_1 );
			if( $ret == null ){
				$ret = $dbGr->insert('bb_ground');
				if( $ret === false ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Ground:"  . $GroundName );
					return BBSB_FRAME_VIEW_INPUT;
				}
				$GroundID = $dbGr->mDb->getInsertId();
				if( !$GroundID ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Ground:"  . $GroundName );
					return BBSB_FRAME_VIEW_INPUT;
				}
			} else {
				$GroundID = $ret[0]['GroundID'];
			}
		}

		// (祳)
		$GameComennt = "";
		$f[7] = str_replace( 'msg=', '', $f[7] );	// "msg=" ʸ
		for( $rcnt = 7 ; $rcnt < count($f) ; $rcnt++ ){
			if( substr($f[$rcnt], 0, 5) == 'senb=' ){
				break;		// ΥãΤǽλ
			}
			$GameComennt .= $f[$rcnt] . "\n";
		}

		// 蹶Хåƥ꡼
		$FirstBattery		= substr( strstr($f[$rcnt],'='), 1);	// 蹶Хåƥ꡼
		$rcnt++;
		// 并Хåƥ꡼
		$LastBattery		= substr( strstr($f[$rcnt],'='), 1);	// 并Хåƥ꡼
		$rcnt++;

		// 蹶并
		$Fidx	= $rcnt; $rcnt++;
		$Lidx	= $rcnt; $rcnt++;
		$FirstTeamID = $LastTeamID = null;
		$lFirst	= explode( ',', substr( strstr($f[$Fidx],'='), 1) );	// 蹶 0:̾1:ס2:()314
		$lLast	= explode( ',', substr( strstr($f[$Lidx],'='), 1) );	// 并
		// Ƚ kihon.cgi(ե)ɤ߹"jiteam"˥åȤƤ뼫̾򽦤
		$kihonfile = $this->mActionForm->mFormProperties['websbpath']->mValue . "/mst/kihon.cgi";
		if( !file_exists( $kihonfile ) ){
			// file not found
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $kihonfile );
			return BBSB_FRAME_VIEW_INPUT;
		}
		$hr = fopen( $kihonfile, "r" );
		if( $hr ){
			while( !feof($hr) ){
				$buf = fgets( $hr );
				if( substr( $buf, 0, 7 ) == "jiteam," ){
					$buf = mb_convert_encoding( $buf, _CHARSET, "SJIS" );		// ʸѴ
					$ownTeamName = trim( substr( strstr($buf,','), 1) );		// ̾
					break;
				}
			}
		} else {
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FILENOTFOUND . ":" . $kihonfile );
			return BBSB_FRAME_VIEW_INPUT;
		}
		fclose( $hr );
		// ̾DBϿƤʤХơ֥Ͽ
		$FirstTeamID = $LastTeamID = null; // 
		if( strpos( $f[$Fidx], $ownTeamName ) > 0 ){		// 蹶ξ
			$FirstTeamID	= 0;							// TeamIDȤƼ(=0)򥻥å
		}
		if( strpos( $f[$Lidx], $ownTeamName ) > 0 ){		// 并फɤ
			$LastTeamID		= 0;							// TeamIDȤƼ(=0)򥻥å
		}
		if( $FirstTeamID === null ){
			$ret = $this->insTeam( $lFirst[0], $EventDate, $FirstTeamID );
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return BBSB_FRAME_VIEW_INPUT;
			}
		}
		if( $LastTeamID === null ){
			$ret = $this->insTeam( $lLast[0], $EventDate, $LastTeamID );
			if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
				return BBSB_FRAME_VIEW_INPUT;
			}
		}

		// Ƚ
		$Result			= null;
		$katimake		=substr( strstr($f[6],'='), 1);			// 
		switch( $katimake ){
			case '0':	// 0嵭̤
				if( $ownTeamName == $lFirst[0] && $ownTeamName != $lLast[0] ){			// ब蹶ΤȤ
					if( $lFirst[1] > $lLast[1] ){
						$Result = '1';							// 蹶ξϼྡ
					} else if( $lFirst[1] < $lLast[1] ){
						$Result = '0';							// 并ξϼ餱
					} else {
						$Result = '2';							// ʬ
					}
				} else if( $ownTeamName != $lFirst[0] && $ownTeamName == $lLast[0] ){	// ब并ΤȤ
					if( $lFirst[1] > $lLast[1] ){
						$Result = '0';							// 蹶ξϼ餱
					} else if( $lFirst[1] < $lLast[1] ){
						$Result = '1';							// 并ξϼྡ
					} else {
						$Result = '2';							// ʬ
					}
				} else {
					$Result = '3';								// ¾ (ʤ)
				}
				break;
			case '1':	// 1:
				$Result = '11';									// 11:
				break;
			case '2':	// 2:ﾡ
				$Result = '21';									// 21:ﾡ
				break;
			case '3':	// 3:¾
				$Result = '31';									// 31:¾
				break;
			case '11':	// 11:餱
				$Result = '10';									// 10:餱
				break;
			case '12':	// 12:
				$Result = '20';									// 20:
				break;
			case '13':	// 13:¾餱
				$Result = '30';									// 30:¾餱
				break;
		}

		// Ƿǡ
		// da= ϤޤԤν 0:̾1:ֹ桢2:ǽ(1)3:(1)4:5:֡6:71819:20ݼ
		$lB		= array();
		$dbM	= new BBSB_DbMember();
		$dcnt	= 0;// Ǽԥ
		$ocnt	= 1;// ǽ祫(1)
		$chgcnt = 0;// 祫
		while( substr($f[$rcnt],0,3) == "da=" ){
			$Dbuf	= explode( ',', substr( strstr($f[$rcnt],'='), 1) );
			if( $dcnt > 0 ){
				if( $Dbufp[2] == $Dbuf[2] ){	// ǽ礬Ʊϸ򣱤䤹
					$chgcnt++;
				} else {
					$chgcnt = 0;
					$ocnt++;					// ǽ礬㤦ǽ祫䤹
				}
			}

			// Ǽֹ̾Ǽ̾DBϿƤʤХХơ֥Ͽ
			$dbM->unsetData();
			$dbM->setData( 'NickName', $Dbuf[0] );		// Ȥꤢ˥å͡򥭡Ƚ
			$ret = $dbM->getListbyCond('bb_member','UserID');
			if( $ret == null ){
				$dbM->setData( 'FullName',	$Dbuf[0] );
				$dbM->setData( 'UniformNo', $Dbuf[1] );	// ֹ
				$ret = $dbM->insert('bb_member');
				if( $ret === false ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Member:"  . $Dbuf[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
				// INSERT줿UserID롣
				$lB[$dcnt]['UserID'] = $dbM->mDb->getInsertId();
				if( !$lB[$dcnt]['UserID'] ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Member:"  . $Dbuf[0] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			} else {
				$lB[$dcnt]['UserID'] = $ret[0]['UserID'];
			}
			$lB[$dcnt]['PlayOrder']		= $ocnt;							// ǽ
			$lB[$dcnt]['ChangeCnt']		= $chgcnt;							// 
			$lB[$dcnt]['Position1']		= intval($Dbuf[5])?  	intval($Dbuf[5]) : null;	// 1 (0NULLȤ)
			$lB[$dcnt]['Position2']		= null;								// ݥ2ϤʤΤnull򥻥å
			$lB[$dcnt]['StolenBaseSuc']	= $Dbuf[4]!=''?  $Dbuf[4] : null;	// 
			$lB[$dcnt]['StolenBaseFail']= $Dbuf[20]!=''? $Dbuf[20]: null;	// ݼ
			$lB[$dcnt]['RunsCnt']		= $Dbuf[19]!=''? $Dbuf[19]: null;	// 
			$lB[$dcnt]['ErrorsCnt']		= $Dbuf[6]!=''?  $Dbuf[6] : null;	// 
			// ˥襹롼
			for( $ccnt = 7 ; $ccnt < 19 ; $ccnt++ ){
				// 
				$Ibuf = $Dbuf[$ccnt];
				if( strpos( $Ibuf, '.' ) ){
					$lD	=  explode( '.', $Ibuf );
					$lB[$dcnt]['Direction'][$ccnt-7]		= $lD[0];
					$Ibuf = $lD[1];
				} else {
					$lB[$dcnt]['Direction'][$ccnt-7]		= null;
				}
				// 桢
				if( strpos( $Ibuf, '/' ) ){
					$lD	=  explode( '/', $Ibuf );
					$lB[$dcnt]['ScoreMarkID'][$ccnt-7]	= $lD[0];
					$lB[$dcnt]['RBI'][$ccnt-7]			= $lD[1];
				} else {
					$lB[$dcnt]['ScoreMarkID'][$ccnt-7]	= $Ibuf;
					$lB[$dcnt]['RBI'][$ccnt-7]			= null;
				}
			}
			$Dbufp	= $Dbuf;	// 1Υǡ¸
			$dcnt++;
			$rcnt++;
		}

		// ˥
		$Inlist	= explode( ',', substr( strstr($f[$rcnt],'='), 1) );
		$rcnt++;

		// ǡ
		// to= ϤޤԤν 0:ֹ桢1:̾2:˥󥰡3:ȥȡ4:5:6:å7:Ϳ͵塢8:Ϳ塢9:ǡ10:ǡ11:12:
		$lP		= array();
		$dbM	= new BBSB_DbMember();
		$pcnt	= 0;// ǡ
		while( substr($f[$rcnt],0,3) == "to=" ){
			$Pbuf	= explode( ',', substr( strstr($f[$rcnt],'='), 1) );

			// ֹ̾̾DBϿƤʤХХơ֥Ͽ
			$dbM->setData( 'NickName', $Pbuf[1] );
			$ret = $dbM->getListbyCond('bb_member','UserID');
			if( $ret == null ){
				$dbM->setData( 'UniformNo', $Pbuf[0] );	// ֹ
				$ret = $dbM->insert('bb_member');
				if( $ret === false ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Member:"  . $Pbuf[1] );
					return BBSB_FRAME_VIEW_INPUT;
				}
				// INSERT줿UserID롣
				$lP[$pcnt]['UserID'] = $dbM->mDb->getInsertId();
				if( !$lP[$pcnt]['UserID'] ){
					$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Member:"  . $Pbuf[1] );
					return BBSB_FRAME_VIEW_INPUT;
				}
			} else {
				$lP[$pcnt]['UserID'] = $ret[0]['UserID'];
			}
			$lP[$pcnt]['ChangeCnt']		= $pcnt;
			$lP[$pcnt]['Innings']		= $Pbuf[2]!=''?  $Pbuf[2] : null;
			$lP[$pcnt]['OutCnt']		= $Pbuf[3]!=''?  $Pbuf[3] : null;
			$lP[$pcnt]['EarnedRuns']	= $Pbuf[4]!=''?  $Pbuf[4] : null;
			$lP[$pcnt]['Runs']			= $Pbuf[5]!=''?  $Pbuf[5] : null;
			$lP[$pcnt]['KCnt']			= $Pbuf[6]!=''?  $Pbuf[6] : null;
			$lP[$pcnt]['BCnt']			= $Pbuf[7]!=''?  $Pbuf[7] : null;
			$lP[$pcnt]['DBCnt']			= $Pbuf[8]!=''?  $Pbuf[8] : null;
			$lP[$pcnt]['HCnt']			= $Pbuf[9]!=''?  $Pbuf[9] : null;
			$lP[$pcnt]['HRCnt']			= $Pbuf[10]!=''? $Pbuf[10]: null;
			$lP[$pcnt]['NumOfPitch']	= $Pbuf[11]!=''? $Pbuf[11]: null;
			$lP[$pcnt]['Win'] = $lP[$pcnt]['Lose'] = $lP[$pcnt]['Save'] = $lP[$pcnt]['Hold'] = 0;
			if( $Pbuf[12] == '1' ){			// 
				$lP[$pcnt]['Win']	= 1;
			} else if( $Pbuf[12] == '2' ){	// 餱
				$lP[$pcnt]['Lose']	= 1;
			} else if( $Pbuf[12] == '3' ){	// 
				$lP[$pcnt]['Save']	= 1;
			}
			$pcnt++;
			$rcnt++;
			if( !isset($f[$rcnt]) ){ break; }
		}

		// ơ֥Ͽ(bb_game)
		$dbGa->unsetData();
		// դȻ礬פǡϿϹԤʤ
		$dbGa->setData( 'EventDate',	$EventDate );
		$dbGa->setData( 'GameSeq',		$GameSeq );
		if( $dbGa->CountNum('bb_game') > 0 ){
			// 礬ϿƤΤǽλ
			$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_ALREADYEXISTS . ":" . $file );
			return BBSB_FRAME_VIEW_SUCCESS;
		}

		// 礬ϿƤʤȤǧǤΤǻϿ
		$dbGa->setData( 'Nendo',		$Nendo );
		$dbGa->setData( 'LeagueID',		$LeagueID );
		$dbGa->setData( 'TournamentID',	$TournamentID );
		$dbGa->setData( 'GameOrderID',	$GameOrderID );
		$dbGa->setData( 'Groundid',		$GroundID );
		$dbGa->setData( 'Result',		$Result );
		$dbGa->setData( 'FirstTeamID',	$FirstTeamID );
		$dbGa->setData( 'LastTeamID',	$LastTeamID );
		$dbGa->setData( 'FirstBattery',	$FirstBattery );
		$dbGa->setData( 'LastBattery',	$LastBattery );
		$dbGa->setData( 'GameComment',	$GameComennt );
		for( $icnt = 0 ; $icnt < 12 ; $icnt++ ){
			$seqstr = sprintf("%02d", $icnt+1);
			$inningtop 		= "Inning" . $seqstr . "top";
			$inningbottom	= "Inning" . $seqstr . "bottom";
			$fscore=null;
			if( $lFirst[$icnt+3]!="" ){
				$fscore=$lFirst[$icnt+3];
			}
			$lscore=null;
			if( $lLast[$icnt+3]!="" ){
				$lscore=$lLast[$icnt+3];
			}
			$dbGa->setData( $inningtop,		$fscore );
			$dbGa->setData( $inningbottom,	$lscore  );
		}
		$dbGa->setData( 'ResultTop',	$lFirst[1] );
		$dbGa->setData( 'ResultBottom',	$lLast[1] );
		$nowstr = 'NOW()';
		$dbGa->setData( 'UpdateTime',	$nowstr );
		$result = $dbGa->insert( 'bb_game' );
		if( $result===false ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Game:"  . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}
		// INSERT줿GameID롣
		$gid = $dbGa->mDb->getInsertId();
		if( !$gid ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Game:"  . $file );
			return BBSB_FRAME_VIEW_INPUT;
		}

		// üԥơ֥Ͽ(bb_gameentrant)
		$ret = $this->insEntrantData( $gid, $lB );
		if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GameEntrant:"  . $file );
			return $ret;
		}

		// Хåơ֥Ͽ(bb_gamebatter)
		$ret = $this->insBatterData( $gid, $Inlist, $lB );
		if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":GameBatter:"  . $file );
			return $ret;
		}

		// ԥå㡼ơ֥Ͽ(bb_gamepitcer)
		$ret = $this->insPitcherData( $gid, $lP );
		if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
			return $ret;
		}

		// Message
		$this->mActionForm->addInfoMessage( _MD_BBSB_INFO_IMPORTSUCCESS . ":GameData:" . $file );

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ϤȤ̾DBϿƤʤϿ롣
	 * ޤǽդй롣
	 * @param $TeamName  IN)̾()
	 * @param $GameDate  IN)(8yyyymmdd)
	 * @param $TeamID    (OUT)ID
	 * @return unknown_type
	 */
	function insTeam( $TeamName, $GameDate, &$TeamID ){
		// ơ֥¸ߤ뤫ɤĴ١ʤХơ֥Ͽ
		$dbOp = new BBSB_DbOpponent();
		$dbOp->setData( 'TeamName', $TeamName );
		$ret = $dbOp->getListbyCond( 'bb_opponent','TeamID,LastGameDate');
		if( $ret == null ){
			// DBϿƤʤȤINSERT
			$dbOp->setData( 'LastGameDate', $GameDate );
			$ret = $dbOp->insert('bb_opponent');
			if( $ret === false ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Opponent:"  . $TeamName );
				return BBSB_FRAME_VIEW_INPUT;
			}
			$TeamID = $dbOp->mDb->getInsertId();
			if( !$TeamID ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DATABASEUPDATE . ":Opponent:"  . $TeamName );
				return BBSB_FRAME_VIEW_INPUT;
			}
		} else {
			//  Ǥ쥳ɤ¸ߤƤ
			$TeamID = $ret[0]['TeamID'];
			// ǽդɤؤ뤫ɤΥåԤ
			$lastdate = date_format(date_create($ret[0]['LastGameDate']),"Ymd");
			if( strcmp($GameDate, $lastdate)>0 ){
				$dbOp->unsetData();
				$dbOp->setData( 'LastGameDate', $GameDate );
				$keyarray = array( 'TeamID'=>$TeamID );
				$result = $dbOp->update( 'bb_opponent', $keyarray );
			}
		}
		return BBSB_FRAME_VIEW_SUCCESS;
	}

}
?>
