<?php
// եࡧϿ

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_ROOT_PATH . "/core/XCube_ActionForm.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGameOrder.class.php";

/***
 * ե९饹Ͽ
 */
class BBSB_EditGameorderdetailForm extends XCube_ActionForm
{
	function prepare()
	{
		// եץѥƥ
		$this->mFormProperties['oid']			=& new XCube_IntProperty('oid');				// ID
		$this->mFormProperties['gameordername']	=& new XCube_StringProperty('gameordername');	// ̾

		// ID
		$this->mFieldProperties['oid']				=& new XCube_FieldProperty($this);
		$this->mFieldProperties['oid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['oid']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_GAMEORDERID, "5");
		$this->mFieldProperties['oid']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_GAMEORDERID);
		$this->mFieldProperties['oid']->addVar('maxlength', 5);
		$this->mFieldProperties['oid']->addVar('min', '1');
		$this->mFieldProperties['oid']->addVar('max', '32767');

		// ̾(ɬ)
		$this->mFieldProperties['gameordername']	=& new XCube_FieldProperty($this);
		$this->mFieldProperties['gameordername']->setDependsByArray(array('required','maxlength'));
		$this->mFieldProperties['gameordername']->addMessage('required',	_MD_BBSB_ERROR_REQUIRED,	_MD_BBSB_LANG_GAMEORDER);
		$this->mFieldProperties['gameordername']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,		_MD_BBSB_LANG_GAMEORDER, '128');
		$this->mFieldProperties['gameordername']->addVar('maxlength', 128);
	}

	/**
	 * ̾  ϥå
	 * @return unknown_type
	 *	ϻˡƱ̾Υ쥳ɤäϥ顼
	 */
	function validateGameOrderName()
	{
		if( $this->get('oid') ){
			$exarray = array( 'GameOrderID' => $this->get('oid') );	// GameOrderID(=)ϳ򥫥оݤˤʤ
		} else {
			$exarray = false;										// GameOrderID̵(=)
		}
		$dbGo = new BBSB_DbGameOrder();
		$dbGo->setData( 'GameOrderName',	$this->get('gameordername') );
		$count = $dbGo->CountNum( 'bb_gameorder', $exarray );
		if( $count != 0 ){
			$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_DUPLICATE, _MD_BBSB_LANG_GAMEORDER));
		}
	}

	/**
	 * 
	 * @see core/XCube_ActionForm#load($obj)
	 */
	function load(&$obj)
	{
	}

}
?>
