<?php
// եࡧ饦Ͽ

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_ROOT_PATH . "/core/XCube_ActionForm.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGround.class.php";

/***
 * ե९饹饦Ͽ
 */
class BBSB_EditGrounddetailForm extends XCube_ActionForm
{
	function prepare()
	{
		// եץѥƥ
		$this->mFormProperties['gid']			=& new XCube_IntProperty('tid');			// 饦ID
		$this->mFormProperties['groundname']	=& new XCube_StringProperty('groundname');	// 饦̾
		$this->mFormProperties['url']			=& new XCube_StringProperty('url');			// URL
		$this->mFormProperties['phoneno']		=& new XCube_StringProperty('phoneno');		// 
		$this->mFormProperties['zipcode']		=& new XCube_StringProperty('zipcode');		// ͹ֹ
		$this->mFormProperties['address']		=& new XCube_StringProperty('address');		// 
		$this->mFormProperties['comments']		=& new XCube_TextProperty('comments');		// 
		$this->mFormProperties['codefield']		=& new XCube_TextProperty('codefield');		// 

		// 饦ID
		$this->mFieldProperties['gid']			=& new XCube_FieldProperty($this);
		$this->mFieldProperties['gid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['gid']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_GROUNDID, "5");
		$this->mFieldProperties['gid']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_GROUNDID);
		$this->mFieldProperties['gid']->addVar('maxlength', 5);
		$this->mFieldProperties['gid']->addVar('min', '1');
		$this->mFieldProperties['gid']->addVar('max', '32767');

		// 饦̾(ɬ)
		$this->mFieldProperties['groundname']	=& new XCube_FieldProperty($this);
		$this->mFieldProperties['groundname']->setDependsByArray(array('required','maxlength'));
		$this->mFieldProperties['groundname']->addMessage('required',	_MD_BBSB_ERROR_REQUIRED,	_MD_BBSB_LANG_GROUND);
		$this->mFieldProperties['groundname']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,		_MD_BBSB_LANG_GROUND, '128');
		$this->mFieldProperties['groundname']->addVar('maxlength', 128);

		// URL
		$this->mFieldProperties['url']			=& new XCube_FieldProperty($this);
		$this->mFieldProperties['url']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['url']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,		_MD_BBSB_LANG_URL, '256');
		$this->mFieldProperties['url']->addVar('maxlength', 256);

		// ֹ
		$this->mFieldProperties['phoneno']		=& new XCube_FieldProperty($this);
		$this->mFieldProperties['phoneno']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['phoneno']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PHONENUMBER, '32');
		$this->mFieldProperties['phoneno']->addVar('maxlength', 32);

		// ͹ֹ
		$this->mFieldProperties['zipcode']		=& new XCube_FieldProperty($this);
		$this->mFieldProperties['zipcode']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['zipcode']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_ZIPCODE, '16');
		$this->mFieldProperties['zipcode']->addVar('maxlength', 16);

		// 
		$this->mFieldProperties['comments']		=& new XCube_FieldProperty($this);
		$this->mFieldProperties['comments']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['comments']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_COMMENT, '10000');
		$this->mFieldProperties['comments']->addVar('maxlength', 10000);

		// 
		$this->mFieldProperties['codefield']	=& new XCube_FieldProperty($this);
		$this->mFieldProperties['codefield']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['codefield']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_CODEFIELD, '10000');
		$this->mFieldProperties['codefield']->addVar('maxlength', 10000);

	}

	/**
	 * ̾  ϥå
	 * @return unknown_type
	 *	ϻˡƱ饦̾Υ쥳ɤäϥ顼
	 */
	function validateGroundName()
	{
		if( $this->get('gid') ){
			$exarray = array( 'GroundID' => $this->get('gid') );	// GroundID(=)ϳ򥫥оݤˤʤ
		} else {
			$exarray = false;										// GroundID̵(=)
		}
		$dbGr = new BBSB_DbGround();
		$dbGr->setData( 'GroundName',	$this->get('groundname') );
		$count = $dbGr->CountNum( 'bb_ground', $exarray );
		if( $count != 0 ){
			$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_DUPLICATE, _MD_BBSB_LANG_GROUND));
		}
	}

	/**
	 * URL ϥå
	 * @return unknown_type
	 */
	function validateUrl()
	{
		$t_url = $this->get('url');
		if (strlen($t_url) > 0) {
			if (!preg_match('/^https?(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/', $t_url)) {
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_INJURY, _MD_BBSB_LANG_URL));
			}
		}
	}

	/**
	 * 
	 * @see core/XCube_ActionForm#load($obj)
	 */
	function load(&$obj)
	{
	}

}
?>
